Index: profile/src/main/java/geniusweb/profile/DefaultPartialOrdering.java
===================================================================
--- profile/src/main/java/geniusweb/profile/DefaultPartialOrdering.java	(revision 22)
+++ profile/src/main/java/geniusweb/profile/DefaultPartialOrdering.java	(revision 24)
@@ -37,8 +37,10 @@
 	/**
 	 * 
-	 * @param name
-	 * @param domain
-	 * @param reservationbid
-	 * @param bids
+	 * @param name           name of the profile
+	 * @param domain         the {@link Domain}
+	 * @param reservationbid the reservation bid, this is the minimum acceptable
+	 *                       bid
+	 * @param bids           a list of bids that this ordering contains
+	 *                       comparisons for
 	 * @param isbetterList   a list of tuples [bid1index, bid2index]. It
 	 *                       indicates that bids[bid1index] isbetterthan
Index: profile/src/main/java/geniusweb/profile/FullOrdering.java
===================================================================
--- profile/src/main/java/geniusweb/profile/FullOrdering.java	(revision 22)
+++ profile/src/main/java/geniusweb/profile/FullOrdering.java	(revision 24)
@@ -11,13 +11,17 @@
 	 * @param bid1 the first item's utility/preference
 	 * @param bid2 the second item's utility/preference
-	 * @return true iff bid1 is considered better or equal (&ge;) than bid 2. In all
-	 *         other cases false is returned.
+	 * @return true iff bid1 is considered better or equal (&ge;) than bid 2. In
+	 *         all other cases false is returned.
 	 * 
 	 *         This predicate should be implemented such that
+	 *         <ul>
 	 *         <li>For all b1 and b2, either b1 &ge; b2 or b2 &ge; b1.
 	 *         <li>b &ge; b (every bid is better or equal to itself)
-	 *         <li>If b1&ge;b2 and b2&ge;b1 then the two bids are considered equally
-	 *         good. Note that this differes from a partial order in mathematics.
-	 *         <li>it behaves transitive: if b1&ge;b2 and b2&ge;b3 then b1&ge;b3.
+	 *         <li>If b1&ge;b2 and b2&ge;b1 then the two bids are considered
+	 *         equally good. Note that this differes from a partial order in
+	 *         mathematics.
+	 *         <li>it behaves transitive: if b1&ge;b2 and b2&ge;b3 then
+	 *         b1&ge;b3.
+	 *         </ul>
 	 */
 	@Override
Index: profile/src/main/java/geniusweb/profile/PartialOrdering.java
===================================================================
--- profile/src/main/java/geniusweb/profile/PartialOrdering.java	(revision 22)
+++ profile/src/main/java/geniusweb/profile/PartialOrdering.java	(revision 24)
@@ -13,13 +13,17 @@
 	 * @param bid1 the first item's utility/preference
 	 * @param bid2 the second item's utility/preference
-	 * @return true iff bid1 is considered better or equal (&ge;) than bid 2. In all
-	 *         other cases false is returned. A bid may not have a &ge; relation at
-	 *         all.
+	 * @return true iff bid1 is considered better or equal (&ge;) than bid 2. In
+	 *         all other cases false is returned. A bid may not have a &ge;
+	 *         relation at all.
 	 * 
 	 *         This predicate should be implemented such that
+	 *         <ul>
 	 *         <li>b &ge; b (every bid is better or equal to itself)
-	 *         <li>If b1&ge;b2 and b2&ge;b1 then the two bids are considered equally
-	 *         good. Note that this differes from a partial order in mathematics.
-	 *         <li>it behaves transitive: if b1&ge;b2 and b2&ge;b3 then b1&ge;b3.
+	 *         <li>If b1&ge;b2 and b2&ge;b1 then the two bids are considered
+	 *         equally good. Note that this differes from a partial order in
+	 *         mathematics.
+	 *         <li>it behaves transitive: if b1&ge;b2 and b2&ge;b3 then
+	 *         b1&ge;b3.
+	 *         </ul>
 	 */
 	boolean isPreferredOrEqual(Bid bid1, Bid bid2);
Index: profile/src/main/java/geniusweb/profile/Profile.java
===================================================================
--- profile/src/main/java/geniusweb/profile/Profile.java	(revision 22)
+++ profile/src/main/java/geniusweb/profile/Profile.java	(revision 24)
@@ -36,10 +36,9 @@
 	 * 
 	 * @return a (hypothetical) bid that is the best alternative to a
-	 *         non-agreement. Only bids that are
-	 *         {@link #isPreferredOrEqual(Bid, Bid)} should be accepted. If a
-	 *         negotiation does not reach an agreement, the party can get this
-	 *         offer somewhere else. This replaces the older notion of a
-	 *         "reservation value" and is more general. If null, there is no
-	 *         reservation bid and any agreement is better than no agreement.
+	 *         non-agreement. Only bids that are equal or better should be
+	 *         accepted. If a negotiation does not reach an agreement, the party
+	 *         can get this offer somewhere else. This replaces the older notion
+	 *         of a "reservation value" and is more general. If null, there is
+	 *         no reservation bid and any agreement is better than no agreement.
 	 * 
 	 */
Index: profile/src/main/java/geniusweb/profile/utilityspace/DiscreteValueSetUtilities.java
===================================================================
--- profile/src/main/java/geniusweb/profile/utilityspace/DiscreteValueSetUtilities.java	(revision 22)
+++ profile/src/main/java/geniusweb/profile/utilityspace/DiscreteValueSetUtilities.java	(revision 24)
@@ -20,6 +20,8 @@
  * issue so may need further checking when used for an actual issue. Constructor
  * guarantees that
+ * <ul>
  * <li>All values in the provided map (the utilities) are in [0,1]
  * <li>All keys are proper {@link DiscreteValue}s
+ * </ul>
  */
 @JsonTypeName("discreteutils")
Index: profile/src/main/java/geniusweb/profile/utilityspace/LinearAdditive.java
===================================================================
--- profile/src/main/java/geniusweb/profile/utilityspace/LinearAdditive.java	(revision 22)
+++ profile/src/main/java/geniusweb/profile/utilityspace/LinearAdditive.java	(revision 24)
@@ -22,5 +22,5 @@
 	/**
 	 * 
-	 * @param issue
+	 * @param issue the issue name
 	 * @return the weight of the given issue
 	 */
Index: profile/src/main/java/geniusweb/profile/utilityspace/LinearAdditiveUtilitySpace.java
===================================================================
--- profile/src/main/java/geniusweb/profile/utilityspace/LinearAdditiveUtilitySpace.java	(revision 22)
+++ profile/src/main/java/geniusweb/profile/utilityspace/LinearAdditiveUtilitySpace.java	(revision 24)
@@ -20,7 +20,9 @@
  * 
  * Constructor guarantees that
+ * <ul>
  * <li>weights are normalized to 1
  * <li>the issues in the utility map and weights map match those in the domain
  * <li>The utilities for each issue are proper {@link ValueSetUtilities} objects
+ * </ul>
  */
 @JsonAutoDetect(fieldVisibility = Visibility.ANY, getterVisibility = Visibility.NONE, setterVisibility = Visibility.NONE, isGetterVisibility = Visibility.NONE)
Index: profile/src/main/java/geniusweb/profile/utilityspace/NumberValueSetUtilities.java
===================================================================
--- profile/src/main/java/geniusweb/profile/utilityspace/NumberValueSetUtilities.java	(revision 22)
+++ profile/src/main/java/geniusweb/profile/utilityspace/NumberValueSetUtilities.java	(revision 24)
@@ -40,5 +40,5 @@
 	 * @param lowUtility  the utility of the {@link #lowValue}
 	 * @param highValue   the high value of the {@link Range}. Must be
-	 *                    >lowValue.
+	 *                    &gt;lowValue.
 	 * @param highUtility the utility of the {@link #highValue}
 	 */
Index: profile/src/main/java/geniusweb/profile/utilityspace/PartsUtilities.java
===================================================================
--- profile/src/main/java/geniusweb/profile/utilityspace/PartsUtilities.java	(revision 22)
+++ profile/src/main/java/geniusweb/profile/utilityspace/PartsUtilities.java	(revision 24)
@@ -19,7 +19,7 @@
 /**
  * Contains utilities of a ProductOfValue of a {@link SumOfGroupsUtilitySpace}.
- * So this is similar to a DiscreteValueSetUtilities but instead of issues this
- * contains an (ordered) list of issues. This object serializes to something
- * like <code> 
+ * So this is similar to a {@link DiscreteValueSetUtilities} but instead of
+ * issues this contains an (ordered) list of issues. This object serializes to
+ * something like <code> 
  * {"partsutils":
  * {"issues":["issue1","issue2"],
@@ -29,5 +29,4 @@
  * N issue values, in the same order as the issues list and with "util"
  * containng the utility value of that set of values.
- * <p>
  */
 @JsonAutoDetect(fieldVisibility = Visibility.ANY, getterVisibility = Visibility.NONE, setterVisibility = Visibility.NONE, isGetterVisibility = Visibility.NONE)
@@ -43,5 +42,5 @@
 	/**
 	 * 
-	 * @param issues
+	 * @param issues list of issues
 	 * @param utils  with keys: list of values and value: utility value for that
 	 *               list of values. All list-of-values missing from the map are
Index: profile/src/main/java/geniusweb/profile/utilityspace/ProductOfValue.java
===================================================================
--- profile/src/main/java/geniusweb/profile/utilityspace/ProductOfValue.java	(revision 22)
+++ profile/src/main/java/geniusweb/profile/utilityspace/ProductOfValue.java	(revision 24)
@@ -19,5 +19,5 @@
 
 	/**
-	 * @param values the values to make a product of
+	 * @param newvals the values to make a product of
 	 */
 	@JsonCreator
Index: profile/src/main/java/geniusweb/profile/utilityspace/SumOfGroupsUtilitySpace.java
===================================================================
--- profile/src/main/java/geniusweb/profile/utilityspace/SumOfGroupsUtilitySpace.java	(revision 22)
+++ profile/src/main/java/geniusweb/profile/utilityspace/SumOfGroupsUtilitySpace.java	(revision 24)
@@ -47,18 +47,15 @@
 
 	/**
-	 * @param domain  the {@link Domain} in which this profile is defined.
-	 * @param name    the name of this profile. Must be simple name (a-Z, 0-9)
-	 * @param utils   a map with key: part names (String) and value: the
-	 *                {@link PartsUtilities} for that part. There MUST NOT be a
-	 *                null part name. All values MUST NOT be null. The
-	 *                PartsUtilities must match the
-	 * @param weights the weight of each part, for the computation of the
-	 *                weighted sum. The parts must be the same as those in the
-	 *                utils map. All weights MUST NOT be null. The weights MUST
-	 *                sum to 1.
-	 * @param resBid  the reservation bid. Only bids that are
-	 *                {@link #isPreferredOrEqual(Bid, Bid)} should be accepted.
-	 *                Can be null, meaning that there is no reservation bid and
-	 *                any agreement is better than no agreement.
+	 * @param domain    the {@link Domain} in which this profile is defined.
+	 * @param name      the name of this profile. Must be simple name (a-Z, 0-9)
+	 * @param partutils a map with key: part names (String) and value: the
+	 *                  {@link PartsUtilities} for that part. There MUST NOT be
+	 *                  a null part name. All values MUST NOT be null. The
+	 *                  PartsUtilities must match the
+	 * @param resBid    the reservation bid. Only bids that are
+	 *                  {@link #isPreferredOrEqual(Bid, Bid)} should be
+	 *                  accepted. Can be null, meaning that there is no
+	 *                  reservation bid and any agreement is better than no
+	 *                  agreement.
 	 * @throws NullPointerException     if values are incorrectly null.
 	 * @throws IllegalArgumentException if preconditions not met.
@@ -68,5 +65,4 @@
 			@JsonProperty("name") String name,
 			@JsonProperty("partUtilities") HashMap<String, PartsUtilities> partutils,
-			// @JsonProperty("partWeights") Map<String, BigDecimal> weights,
 			@JsonProperty("reservationBid") Bid resBid) {
 		super(name, domain, resBid);
Index: profile/src/main/java/geniusweb/profile/utilityspace/ValueSetUtilities.java
===================================================================
--- profile/src/main/java/geniusweb/profile/utilityspace/ValueSetUtilities.java	(revision 22)
+++ profile/src/main/java/geniusweb/profile/utilityspace/ValueSetUtilities.java	(revision 24)
@@ -5,9 +5,8 @@
 import com.fasterxml.jackson.annotation.JsonSubTypes;
 import com.fasterxml.jackson.annotation.JsonSubTypes.Type;
+import com.fasterxml.jackson.annotation.JsonTypeInfo;
 
 import geniusweb.issuevalue.Value;
 import geniusweb.issuevalue.ValueSet;
-
-import com.fasterxml.jackson.annotation.JsonTypeInfo;
 
 /**
@@ -16,11 +15,12 @@
  */
 @JsonTypeInfo(use = JsonTypeInfo.Id.NAME, include = JsonTypeInfo.As.WRAPPER_OBJECT)
-@JsonSubTypes({ @Type(value = DiscreteValueSetUtilities.class), @Type(value = NumberValueSetUtilities.class) })
+@JsonSubTypes({ @Type(value = DiscreteValueSetUtilities.class),
+		@Type(value = NumberValueSetUtilities.class) })
 public interface ValueSetUtilities {
 	/**
 	 * 
-	 * @param value
-	 * @return the utility of the given value. MUST be in [0,1]. Should return 0 if
-	 *         the value is unknown.
+	 * @param value the {@link Value} to get the utility for
+	 * @return the utility of the given value. MUST be in [0,1]. Should return 0
+	 *         if the value is unknown.
 	 */
 	BigDecimal getUtility(Value value);
@@ -28,8 +28,8 @@
 	/**
 	 * 
-	 * @param values the valueset that
+	 * @param valueset the valueset that is supposed match with this
 	 * @return null if the ValueSetUtilities fits the given set of values , that
-	 *         means it can give utilities for all possible values in valueset. Or a
-	 *         string containing an explanation why not.
+	 *         means it can give utilities for all possible values in valueset.
+	 *         Or a string containing an explanation why not.
 	 */
 	String isFitting(ValueSet valueset);