Index: exampleparties/anac2019/agentgg/pom.xml
===================================================================
--- exampleparties/anac2019/agentgg/pom.xml	(revision 26)
+++ exampleparties/anac2019/agentgg/pom.xml	(revision 27)
@@ -6,5 +6,5 @@
 	<groupId>geniusweb.exampleparties.anac2019</groupId>
 	<artifactId>agentgg</artifactId>
-	<version>1.5.5</version> <!-- must equal ${geniusweb.version} -->
+	<version>1.5.6</version> <!-- must equal ${geniusweb.version} -->
 	<packaging>jar</packaging>
 
@@ -17,5 +17,5 @@
 		<passwd>${env.ARTIFACTORY_PASS}</passwd>
 		<jackson-2-version>2.9.6</jackson-2-version>
-		<geniusweb.version>1.5.5</geniusweb.version>
+		<geniusweb.version>1.5.6</geniusweb.version>
 	</properties>
 
Index: exampleparties/anac2019/agentgg/src/main/java/geniusweb/exampleparties/agentgg/AgentGG.java
===================================================================
--- exampleparties/anac2019/agentgg/src/main/java/geniusweb/exampleparties/agentgg/AgentGG.java	(revision 26)
+++ exampleparties/anac2019/agentgg/src/main/java/geniusweb/exampleparties/agentgg/AgentGG.java	(revision 27)
@@ -5,4 +5,5 @@
 import java.io.IOException;
 import java.util.Arrays;
+import java.util.Collections;
 import java.util.HashMap;
 import java.util.HashSet;
@@ -28,4 +29,5 @@
 import geniusweb.party.Capabilities;
 import geniusweb.party.DefaultParty;
+import geniusweb.profile.DefaultPartialOrdering;
 import geniusweb.profile.PartialOrdering;
 import geniusweb.profileconnection.ProfileConnectionFactory;
@@ -106,5 +108,6 @@
 	@Override
 	public Capabilities getCapabilities() {
-		return new Capabilities(new HashSet<>(Arrays.asList("SAOP")));
+		return new Capabilities(new HashSet<>(Arrays.asList("SAOP")),
+				Collections.singleton(DefaultPartialOrdering.class));
 	}
 
Index: exampleparties/anac2019/winkyagent/pom.xml
===================================================================
--- exampleparties/anac2019/winkyagent/pom.xml	(revision 26)
+++ exampleparties/anac2019/winkyagent/pom.xml	(revision 27)
@@ -6,5 +6,5 @@
 	<groupId>geniusweb.exampleparties.anac2019</groupId>
 	<artifactId>winkyagent</artifactId>
-	<version>1.5.5</version> <!-- must equal ${geniusweb.version} -->
+	<version>1.5.6</version> <!-- must equal ${geniusweb.version} -->
 	<packaging>jar</packaging>
 
@@ -17,5 +17,5 @@
 		<passwd>${env.ARTIFACTORY_PASS}</passwd>
 		<jackson-2-version>2.9.6</jackson-2-version>
-		<geniusweb.version>1.5.5</geniusweb.version>
+		<geniusweb.version>1.5.6</geniusweb.version>
 	</properties>
 
Index: exampleparties/anac2019/winkyagent/src/main/java/geniusweb/exampleparties/anac2019/winkyagent/WinkyAgent.java
===================================================================
--- exampleparties/anac2019/winkyagent/src/main/java/geniusweb/exampleparties/anac2019/winkyagent/WinkyAgent.java	(revision 26)
+++ exampleparties/anac2019/winkyagent/src/main/java/geniusweb/exampleparties/anac2019/winkyagent/WinkyAgent.java	(revision 27)
@@ -4,4 +4,5 @@
 import java.util.ArrayList;
 import java.util.Arrays;
+import java.util.Collections;
 import java.util.Comparator;
 import java.util.HashMap;
@@ -31,4 +32,5 @@
 import geniusweb.party.Capabilities;
 import geniusweb.party.DefaultParty;
+import geniusweb.profile.DefaultPartialOrdering;
 import geniusweb.profile.PartialOrdering;
 import geniusweb.profileconnection.ProfileConnectionFactory;
@@ -106,5 +108,6 @@
 	@Override
 	public Capabilities getCapabilities() {
-		return new Capabilities(new HashSet<>(Arrays.asList("SAOP")));
+		return new Capabilities(new HashSet<>(Arrays.asList("SAOP")),
+				Collections.singleton(DefaultPartialOrdering.class));
 	}
 
Index: exampleparties/boulware/pom.xml
===================================================================
--- exampleparties/boulware/pom.xml	(revision 26)
+++ exampleparties/boulware/pom.xml	(revision 27)
@@ -6,5 +6,5 @@
 	<groupId>geniusweb.exampleparties</groupId>
 	<artifactId>boulware</artifactId>
-	<version>1.5.5</version> <!-- must equal ${geniusweb.version} -->
+	<version>1.5.6</version> <!-- must equal ${geniusweb.version} -->
 	<packaging>jar</packaging>
 
@@ -17,5 +17,5 @@
 		<passwd>${env.ARTIFACTORY_PASS}</passwd>
 		<jackson-2-version>2.9.10</jackson-2-version>
-		<geniusweb.version>1.5.5</geniusweb.version>
+		<geniusweb.version>1.5.6</geniusweb.version>
 	</properties>
 
Index: exampleparties/comparebids/pom.xml
===================================================================
--- exampleparties/comparebids/pom.xml	(revision 26)
+++ exampleparties/comparebids/pom.xml	(revision 27)
@@ -6,5 +6,5 @@
 	<groupId>geniusweb.exampleparties</groupId>
 	<artifactId>comparebids</artifactId>
-	<version>1.5.5</version> <!-- must equal ${geniusweb.version} -->
+	<version>1.5.6</version> <!-- must equal ${geniusweb.version} -->
 	<packaging>jar</packaging>
 
@@ -17,5 +17,5 @@
 		<passwd>${env.ARTIFACTORY_PASS}</passwd>
 		<jackson-2-version>2.9.6</jackson-2-version>
-		<geniusweb.version>1.5.5</geniusweb.version>
+		<geniusweb.version>1.5.6</geniusweb.version>
 	</properties>
 
Index: exampleparties/comparebids/src/main/java/geniusweb/exampleparties/comparebids/CompareBids.java
===================================================================
--- exampleparties/comparebids/src/main/java/geniusweb/exampleparties/comparebids/CompareBids.java	(revision 26)
+++ exampleparties/comparebids/src/main/java/geniusweb/exampleparties/comparebids/CompareBids.java	(revision 27)
@@ -3,4 +3,5 @@
 import java.io.IOException;
 import java.util.Arrays;
+import java.util.Collections;
 import java.util.HashSet;
 import java.util.LinkedList;
@@ -66,5 +67,6 @@
 	@Override
 	public Capabilities getCapabilities() {
-		return new Capabilities(new HashSet<>(Arrays.asList("COB")));
+		return new Capabilities(new HashSet<>(Arrays.asList("COB")),
+				Collections.singleton(PartialOrdering.class));
 	}
 
Index: exampleparties/conceder/pom.xml
===================================================================
--- exampleparties/conceder/pom.xml	(revision 26)
+++ exampleparties/conceder/pom.xml	(revision 27)
@@ -6,5 +6,5 @@
 	<groupId>geniusweb.exampleparties</groupId>
 	<artifactId>conceder</artifactId>
-	<version>1.5.5</version> <!-- must equal ${geniusweb.version} -->
+	<version>1.5.6</version> <!-- must equal ${geniusweb.version} -->
 	<packaging>jar</packaging>
 
@@ -17,5 +17,5 @@
 		<passwd>${env.ARTIFACTORY_PASS}</passwd>
 		<jackson-2-version>2.9.10</jackson-2-version>
-		<geniusweb.version>1.5.5</geniusweb.version>
+		<geniusweb.version>1.5.6</geniusweb.version>
 	</properties>
 
Index: exampleparties/hardliner/pom.xml
===================================================================
--- exampleparties/hardliner/pom.xml	(revision 26)
+++ exampleparties/hardliner/pom.xml	(revision 27)
@@ -6,5 +6,5 @@
 	<groupId>geniusweb.exampleparties</groupId>
 	<artifactId>hardliner</artifactId>
-	<version>1.5.5</version> <!-- must equal ${geniusweb.version} -->
+	<version>1.5.6</version> <!-- must equal ${geniusweb.version} -->
 	<packaging>jar</packaging>
 
@@ -17,5 +17,5 @@
 		<passwd>${env.ARTIFACTORY_PASS}</passwd>
 		<jackson-2-version>2.9.10</jackson-2-version>
-		<geniusweb.version>1.5.5</geniusweb.version>
+		<geniusweb.version>1.5.6</geniusweb.version>
 	</properties>
 
Index: exampleparties/humangui/pom.xml
===================================================================
--- exampleparties/humangui/pom.xml	(revision 26)
+++ exampleparties/humangui/pom.xml	(revision 27)
@@ -6,5 +6,5 @@
 	<groupId>geniusweb.exampleparties</groupId>
 	<artifactId>humangui</artifactId>
-	<version>1.5.5</version> <!-- must equal ${geniusweb.version} -->
+	<version>1.5.6</version> <!-- must equal ${geniusweb.version} -->
 	<packaging>jar</packaging>
 
@@ -17,5 +17,5 @@
 		<passwd>${env.ARTIFACTORY_PASS}</passwd>
 		<jackson-2-version>2.9.6</jackson-2-version>
-		<geniusweb.version>1.5.5</geniusweb.version>
+		<geniusweb.version>1.5.6</geniusweb.version>
 	</properties>
 
Index: exampleparties/humangui/src/main/java/geniusweb/exampleparties/humangui/HumanGui.java
===================================================================
--- exampleparties/humangui/src/main/java/geniusweb/exampleparties/humangui/HumanGui.java	(revision 26)
+++ exampleparties/humangui/src/main/java/geniusweb/exampleparties/humangui/HumanGui.java	(revision 27)
@@ -3,4 +3,5 @@
 import java.awt.BorderLayout;
 import java.util.Arrays;
+import java.util.Collections;
 import java.util.HashSet;
 import java.util.logging.Level;
@@ -19,4 +20,5 @@
 import geniusweb.party.DefaultParty;
 import geniusweb.party.Party;
+import geniusweb.profile.Profile;
 import geniusweb.profileconnection.ProfileConnectionFactory;
 import geniusweb.profileconnection.ProfileInterface;
@@ -82,5 +84,6 @@
 	@Override
 	public Capabilities getCapabilities() {
-		return new Capabilities(new HashSet<>(Arrays.asList("SAOP")));
+		return new Capabilities(new HashSet<>(Arrays.asList("SAOP")),
+				Collections.singleton(Profile.class));
 	}
 
Index: exampleparties/linear/pom.xml
===================================================================
--- exampleparties/linear/pom.xml	(revision 26)
+++ exampleparties/linear/pom.xml	(revision 27)
@@ -6,5 +6,5 @@
 	<groupId>geniusweb.exampleparties</groupId>
 	<artifactId>linear</artifactId>
-	<version>1.5.5</version> <!-- must equal ${geniusweb.version} -->
+	<version>1.5.6</version> <!-- must equal ${geniusweb.version} -->
 	<packaging>jar</packaging>
 
@@ -17,5 +17,5 @@
 		<passwd>${env.ARTIFACTORY_PASS}</passwd>
 		<jackson-2-version>2.9.10</jackson-2-version>
-		<geniusweb.version>1.5.5</geniusweb.version>
+		<geniusweb.version>1.5.6</geniusweb.version>
 	</properties>
 
Index: exampleparties/randomparty/pom.xml
===================================================================
--- exampleparties/randomparty/pom.xml	(revision 26)
+++ exampleparties/randomparty/pom.xml	(revision 27)
@@ -6,5 +6,5 @@
 	<groupId>geniusweb.exampleparties</groupId>
 	<artifactId>randomparty</artifactId>
-	<version>1.5.5</version> <!-- must equal ${geniusweb.version} -->
+	<version>1.5.6</version> <!-- must equal ${geniusweb.version} -->
 	<packaging>jar</packaging>
 
@@ -17,5 +17,5 @@
 		<passwd>${env.ARTIFACTORY_PASS}</passwd>
 		<jackson-2-version>2.9.6</jackson-2-version>
-		<geniusweb.version>1.5.5</geniusweb.version>
+		<geniusweb.version>1.5.6</geniusweb.version>
 	</properties>
 
Index: exampleparties/randomparty/src/main/java/geniusweb/exampleparties/randomparty/RandomParty.java
===================================================================
--- exampleparties/randomparty/src/main/java/geniusweb/exampleparties/randomparty/RandomParty.java	(revision 26)
+++ exampleparties/randomparty/src/main/java/geniusweb/exampleparties/randomparty/RandomParty.java	(revision 27)
@@ -4,4 +4,5 @@
 import java.math.BigInteger;
 import java.util.Arrays;
+import java.util.Collections;
 import java.util.HashSet;
 import java.util.Random;
@@ -109,5 +110,6 @@
 	public Capabilities getCapabilities() {
 		return new Capabilities(
-				new HashSet<>(Arrays.asList("SAOP", "AMOP", "MOPAC")));
+				new HashSet<>(Arrays.asList("SAOP", "AMOP", "MOPAC")),
+				Collections.singleton(Profile.class));
 	}
 
Index: exampleparties/randompartypy/pom.xml
===================================================================
--- exampleparties/randompartypy/pom.xml	(revision 26)
+++ exampleparties/randompartypy/pom.xml	(revision 27)
@@ -6,5 +6,5 @@
 	<groupId>geniusweb.exampleparties</groupId>
 	<artifactId>randompyparty</artifactId>
-	<version>1.5.5</version> <!-- must equal ${geniusweb.version} -->
+	<version>1.5.6</version> <!-- must equal ${geniusweb.version} -->
 	<packaging>jar</packaging>
 
@@ -17,5 +17,5 @@
 		<passwd>${env.ARTIFACTORY_PASS}</passwd>
 		<jackson-2-version>2.9.10</jackson-2-version>
-		<geniusweb.version>1.5.5</geniusweb.version>
+		<geniusweb.version>1.5.6</geniusweb.version>
 	</properties>
 
Index: exampleparties/randompartypy/src/main/resources/RandomParty.py
===================================================================
--- exampleparties/randompartypy/src/main/resources/RandomParty.py	(revision 26)
+++ exampleparties/randompartypy/src/main/resources/RandomParty.py	(revision 27)
@@ -13,4 +13,5 @@
 import java.util.HashSet as HashSet
 import java.util.Random as Random
+import java.util.Collections as Collections
  
 import geniusweb.actions.Accept as Accept
@@ -65,5 +66,5 @@
 	# Override
 	def getCapabilities(self): # -> Capabilities
-			return Capabilities(HashSet([ "SAOP"]))
+			return Capabilities(HashSet([ "SAOP"]), Collections.singleton(Profile));
 
 	# Override
Index: exampleparties/simpleboa/pom.xml
===================================================================
--- exampleparties/simpleboa/pom.xml	(revision 26)
+++ exampleparties/simpleboa/pom.xml	(revision 27)
@@ -6,5 +6,5 @@
 	<groupId>geniusweb.exampleparties</groupId>
 	<artifactId>simpleboaparty</artifactId>
-	<version>1.5.5</version> <!-- must equal ${geniusweb.version} -->
+	<version>1.5.6</version> <!-- must equal ${geniusweb.version} -->
 	<packaging>jar</packaging>
 
@@ -17,5 +17,5 @@
 		<passwd>${env.ARTIFACTORY_PASS}</passwd>
 		<jackson-2-version>2.9.6</jackson-2-version>
-		<geniusweb.version>1.5.5</geniusweb.version>
+		<geniusweb.version>1.5.6</geniusweb.version>
 	</properties>
 
Index: exampleparties/simpleshaop/pom.xml
===================================================================
--- exampleparties/simpleshaop/pom.xml	(revision 26)
+++ exampleparties/simpleshaop/pom.xml	(revision 27)
@@ -6,5 +6,5 @@
 	<groupId>geniusweb.exampleparties</groupId>
 	<artifactId>simpleshaop</artifactId>
-	<version>1.5.5</version> <!-- must equal ${geniusweb.version} -->
+	<version>1.5.6</version> <!-- must equal ${geniusweb.version} -->
 	<packaging>jar</packaging>
 
@@ -17,5 +17,5 @@
 		<passwd>${env.ARTIFACTORY_PASS}</passwd>
 		<jackson-2-version>2.9.6</jackson-2-version>
-		<geniusweb.version>1.5.5</geniusweb.version>
+		<geniusweb.version>1.5.6</geniusweb.version>
 	</properties>
 
Index: exampleparties/simpleshaop/src/main/java/geniusweb/exampleparties/simpleshaop/ShaopParty.java
===================================================================
--- exampleparties/simpleshaop/src/main/java/geniusweb/exampleparties/simpleshaop/ShaopParty.java	(revision 26)
+++ exampleparties/simpleshaop/src/main/java/geniusweb/exampleparties/simpleshaop/ShaopParty.java	(revision 27)
@@ -5,4 +5,5 @@
 import java.math.BigInteger;
 import java.util.Arrays;
+import java.util.Collections;
 import java.util.HashSet;
 import java.util.Random;
@@ -24,4 +25,5 @@
 import geniusweb.party.Capabilities;
 import geniusweb.party.DefaultParty;
+import geniusweb.profile.DefaultPartialOrdering;
 import geniusweb.profile.PartialOrdering;
 import geniusweb.profileconnection.ProfileConnectionFactory;
@@ -90,5 +92,6 @@
 	@Override
 	public Capabilities getCapabilities() {
-		return new Capabilities(new HashSet<>(Arrays.asList("SHAOP")));
+		return new Capabilities(new HashSet<>(Arrays.asList("SHAOP")),
+				Collections.singleton(DefaultPartialOrdering.class));
 	}
 
Index: exampleparties/timedependentparty/pom.xml
===================================================================
--- exampleparties/timedependentparty/pom.xml	(revision 26)
+++ exampleparties/timedependentparty/pom.xml	(revision 27)
@@ -6,5 +6,5 @@
 	<groupId>geniusweb.exampleparties</groupId>
 	<artifactId>timedependentparty</artifactId>
-	<version>1.5.5</version> <!-- must equal ${geniusweb.version} -->
+	<version>1.5.6</version> <!-- must equal ${geniusweb.version} -->
 	<packaging>jar</packaging>
 
@@ -17,5 +17,5 @@
 		<passwd>${env.ARTIFACTORY_PASS}</passwd>
 		<jackson-2-version>2.9.10</jackson-2-version>
-		<geniusweb.version>1.5.5</geniusweb.version>
+		<geniusweb.version>1.5.6</geniusweb.version>
 	</properties>
 
Index: exampleparties/timedependentparty/src/main/java/geniusweb/exampleparties/timedependentparty/TimeDependentParty.java
===================================================================
--- exampleparties/timedependentparty/src/main/java/geniusweb/exampleparties/timedependentparty/TimeDependentParty.java	(revision 26)
+++ exampleparties/timedependentparty/src/main/java/geniusweb/exampleparties/timedependentparty/TimeDependentParty.java	(revision 27)
@@ -6,4 +6,5 @@
 import java.math.RoundingMode;
 import java.util.Arrays;
+import java.util.Collections;
 import java.util.HashSet;
 import java.util.Random;
@@ -92,5 +93,6 @@
 	@Override
 	public Capabilities getCapabilities() {
-		return new Capabilities(new HashSet<>(Arrays.asList("SAOP", "MOPAC")));
+		return new Capabilities(new HashSet<>(Arrays.asList("SAOP", "MOPAC")),
+				Collections.singleton(LinearAdditive.class));
 	}
 