Index: src/main/webapp/domainsrepo/7issues/7issues.json
===================================================================
--- src/main/webapp/domainsrepo/7issues/7issues.json	(revision 27)
+++ src/main/webapp/domainsrepo/7issues/7issues.json	(revision 28)
@@ -3,23 +3,23 @@
 	"issuesValues": {
 		"i1": {
-			"range": [0, 9, 1]
+			"range": {"low":0,"high":9,"step":1} 
 		},
 		"i2": {
-			"range": [0, 9, 1]
+			"range": {"low":0,"high":9,"step":1} 
 		},
 		"i3": {
-			"range": [0, 9, 1]
+			"range": {"low":0,"high":9,"step":1} 
 		},
 		"i4": {
-			"range": [0, 9, 1]
+			"range": {"low":0,"high":9,"step":1} 
 		},
 		"i5": {
-			"range": [0, 9, 1]
+			"range": {"low":0,"high":9,"step":1} 
 		},
 		"i6": {
-			"range": [0, 9, 1]
+			"range": {"low":0,"high":9,"step":1} 
 		},
 		"i7": {
-			"range": [0, 9, 1]
+			"range": {"low":0,"high":9,"step":1} 
 		}
 	}
Index: src/main/webapp/domainsrepo/7issues/7issues1.json
===================================================================
--- src/main/webapp/domainsrepo/7issues/7issues1.json	(revision 27)
+++ src/main/webapp/domainsrepo/7issues/7issues1.json	(revision 28)
@@ -4,5 +4,5 @@
 		"issueUtilities": {
 			"i1": {
-				"numberutils": {
+				"NumberValueSetUtilities": {
 					"lowValue": 0,
 					"lowUtility": 0.11,
@@ -12,5 +12,5 @@
 			},
 			"i2": {
-				"numberutils": {
+				"NumberValueSetUtilities": {
 					"lowValue": 0,
 					"lowUtility": 0.12,
@@ -20,5 +20,5 @@
 			},
 			"i3": {
-				"numberutils": {
+				"NumberValueSetUtilities": {
 					"lowValue": 0,
 					"lowUtility": 0.13,
@@ -28,5 +28,5 @@
 			},
 			"i4": {
-				"numberutils": {
+				"NumberValueSetUtilities": {
 					"lowValue": 0,
 					"lowUtility": 0.14,
@@ -36,5 +36,5 @@
 			},
 			"i5": {
-				"numberutils": {
+				"NumberValueSetUtilities": {
 					"lowValue": 0,
 					"lowUtility": 0.15,
@@ -44,5 +44,5 @@
 			},
 			"i6": {
-				"numberutils": {
+				"NumberValueSetUtilities": {
 					"lowValue": 0,
 					"lowUtility": 0.16,
@@ -52,5 +52,5 @@
 			},
 			"i7": {
-				"numberutils": {
+				"NumberValueSetUtilities": {
 					"lowValue": 0,
 					"lowUtility": 0.16,
@@ -73,51 +73,23 @@
 			"issuesValues": {
 				"i1": {
-					"range": [
-						0,
-						9,
-						1
-					]
+					"range": {"low":0,"high":9,"step":1} 
 				},
 				"i2": {
-					"range": [
-						0,
-						9,
-						1
-					]
+					"range": {"low":0,"high":9,"step":1} 
 				},
 				"i3": {
-					"range": [
-						0,
-						9,
-						1
-					]
+					"range": {"low":0,"high":9,"step":1} 
 				},
 				"i4": {
-					"range": [
-						0,
-						9,
-						1
-					]
+					"range": {"low":0,"high":9,"step":1} 
 				},
 				"i5": {
-					"range": [
-						0,
-						9,
-						1
-					]
+					"range": {"low":0,"high":9,"step":1} 
 				},
 				"i6": {
-					"range": [
-						0,
-						9,
-						1
-					]
+					"range": {"low":0,"high":9,"step":1} 
 				},
 				"i7": {
-					"range": [
-						0,
-						9,
-						1
-					]
+					"range": {"low":0,"high":9,"step":1} 
 				}
 			}
Index: src/main/webapp/domainsrepo/7issues/7issues2.json
===================================================================
--- src/main/webapp/domainsrepo/7issues/7issues2.json	(revision 27)
+++ src/main/webapp/domainsrepo/7issues/7issues2.json	(revision 28)
@@ -4,5 +4,5 @@
 		"issueUtilities": {
 			"i1": {
-				"numberutils": {
+				"NumberValueSetUtilities": {
 					"lowValue": 0,
 					"lowUtility": 0.51,
@@ -12,5 +12,5 @@
 			},
 			"i2": {
-				"numberutils": {
+				"NumberValueSetUtilities": {
 					"lowValue": 0,
 					"lowUtility": 0.92,
@@ -20,5 +20,5 @@
 			},
 			"i3": {
-				"numberutils": {
+				"NumberValueSetUtilities": {
 					"lowValue": 0,
 					"lowUtility": 0.93,
@@ -28,5 +28,5 @@
 			},
 			"i4": {
-				"numberutils": {
+				"NumberValueSetUtilities": {
 					"lowValue": 0,
 					"lowUtility": 0.94,
@@ -36,5 +36,5 @@
 			},
 			"i5": {
-				"numberutils": {
+				"NumberValueSetUtilities": {
 					"lowValue": 0,
 					"lowUtility": 0.95,
@@ -44,5 +44,5 @@
 			},
 			"i6": {
-				"numberutils": {
+				"NumberValueSetUtilities": {
 					"lowValue": 0,
 					"lowUtility": 0.96,
@@ -52,5 +52,5 @@
 			},
 			"i7": {
-				"numberutils": {
+				"NumberValueSetUtilities": {
 					"lowValue": 0,
 					"lowUtility": 0.97,
@@ -61,11 +61,11 @@
 		},
 		"issueWeights": {
-			"i1": 0.24745759773026107,
-			"i2": 0.11824193959921694,
-			"i3": 0.1860471425098606,
-			"i4": 0.20629555826677742,
-			"i5": 0.16112666189388397,
+			"i1": 0.24746,
+			"i2": 0.118241,
+			"i3": 0.186047,
+			"i4": 0.206295,
+			"i5": 0.161126,
 			"i6": 0.0538874,
-			"i7": 0.0269437
+			"i7": 0.0269436
 		},
 		"domain": {
@@ -73,51 +73,23 @@
 			"issuesValues": {
 				"i1": {
-					"range": [
-						0,
-						9,
-						1
-					]
+					"range": {"low":0,"high":9,"step":1} 
 				},
 				"i2": {
-					"range": [
-						0,
-						9,
-						1
-					]
+					"range": {"low":0,"high":9,"step":1} 
 				},
 				"i3": {
-					"range": [
-						0,
-						9,
-						1
-					]
+					"range": {"low":0,"high":9,"step":1} 
 				},
 				"i4": {
-					"range": [
-						0,
-						9,
-						1
-					]
+					"range": {"low":0,"high":9,"step":1} 
 				},
 				"i5": {
-					"range": [
-						0,
-						9,
-						1
-					]
+					"range": {"low":0,"high":9,"step":1} 
 				},
 				"i6": {
-					"range": [
-						0,
-						9,
-						1
-					]
+					"range": {"low":0,"high":9,"step":1} 
 				},
 				"i7": {
-					"range": [
-						0,
-						9,
-						1
-					]
+					"range": {"low":0,"high":9,"step":1} 
 				}
 			}
Index: src/main/webapp/domainsrepo/fitness/fitness1.json
===================================================================
--- src/main/webapp/domainsrepo/fitness/fitness1.json	(revision 27)
+++ src/main/webapp/domainsrepo/fitness/fitness1.json	(revision 28)
@@ -3,5 +3,5 @@
 		"issueUtilities": {
 			"type": {
-				"discreteutils": {
+				"DiscreteValueSetUtilities": {
 					"valueUtilities": {
 						"swimming": 0.6,
@@ -14,5 +14,5 @@
 			},
 			"duration": {
-				"discreteutils": {
+				"DiscreteValueSetUtilities": {
 					"valueUtilities": {
 						"30 min": 0.44,
@@ -24,5 +24,5 @@
 			},
 			"distance": {
-				"discreteutils": {
+				"DiscreteValueSetUtilities": {
 					"valueUtilities": {
 						"0 km": 0.75,
@@ -34,5 +34,5 @@
 			},
 			"intensity": {
-				"discreteutils": {
+				"DiscreteValueSetUtilities": {
 					"valueUtilities": {
 						"light": 0.3,
@@ -44,5 +44,5 @@
 			},
 			"price": {
-				"discreteutils": {
+				"DiscreteValueSetUtilities": {
 					"valueUtilities": {
 						"$5": 1.0,
Index: src/main/webapp/domainsrepo/fitness/fitness2.json
===================================================================
--- src/main/webapp/domainsrepo/fitness/fitness2.json	(revision 27)
+++ src/main/webapp/domainsrepo/fitness/fitness2.json	(revision 28)
@@ -3,5 +3,5 @@
 		"issueUtilities": {
 			"type": {
-				"discreteutils": {
+				"DiscreteValueSetUtilities": {
 					"valueUtilities": {
 						"swimming": 1.0,
@@ -14,5 +14,5 @@
 			},
 			"duration": {
-				"discreteutils": {
+				"DiscreteValueSetUtilities": {
 					"valueUtilities": {
 						"30 min": 0.15,
@@ -24,5 +24,5 @@
 			},
 			"distance": {
-				"discreteutils": {
+				"DiscreteValueSetUtilities": {
 					"valueUtilities": {
 						"0 km": 1.0,
@@ -34,5 +34,5 @@
 			},
 			"intensity": {
-				"discreteutils": {
+				"DiscreteValueSetUtilities": {
 					"valueUtilities": {
 						"light": 1.0,
@@ -44,5 +44,5 @@
 			},
 			"price": {
-				"discreteutils": {
+				"DiscreteValueSetUtilities": {
 					"valueUtilities": {
 						"$5": 0.18,
Index: src/main/webapp/domainsrepo/flightbooking/flightbooking1.json
===================================================================
--- src/main/webapp/domainsrepo/flightbooking/flightbooking1.json	(revision 27)
+++ src/main/webapp/domainsrepo/flightbooking/flightbooking1.json	(revision 28)
@@ -3,5 +3,5 @@
 		"issueUtilities": {
 			"price": {
-				"discreteutils": {
+				"DiscreteValueSetUtilities": {
 					"valueUtilities": {
 						"150000yen": 0.25,
@@ -13,5 +13,5 @@
 			},
 			"departure airport": {
-				"discreteutils": {
+				"DiscreteValueSetUtilities": {
 					"valueUtilities": {
 						"CentAir": 0.667,
@@ -22,5 +22,5 @@
 			},
 			"departure date": {
-				"discreteutils": {
+				"DiscreteValueSetUtilities": {
 					"valueUtilities": {
 						"2 sept.": 0.333,
Index: src/main/webapp/domainsrepo/flightbooking/flightbooking2.json
===================================================================
--- src/main/webapp/domainsrepo/flightbooking/flightbooking2.json	(revision 27)
+++ src/main/webapp/domainsrepo/flightbooking/flightbooking2.json	(revision 28)
@@ -3,5 +3,5 @@
 		"issueUtilities": {
 			"price": {
-				"discreteutils": {
+				"DiscreteValueSetUtilities": {
 					"valueUtilities": {
 						"150000yen": 1.0,
@@ -13,5 +13,5 @@
 			},
 			"departure airport": {
-				"discreteutils": {
+				"DiscreteValueSetUtilities": {
 					"valueUtilities": {
 						"CentAir": 0.333,
@@ -22,5 +22,5 @@
 			},
 			"departure date": {
-				"discreteutils": {
+				"DiscreteValueSetUtilities": {
 					"valueUtilities": {
 						"2 sept.": 1.0,
Index: src/main/webapp/domainsrepo/japantrip/japantrip.json
===================================================================
--- src/main/webapp/domainsrepo/japantrip/japantrip.json	(revision 27)
+++ src/main/webapp/domainsrepo/japantrip/japantrip.json	(revision 28)
@@ -11,9 +11,5 @@
 		},
 		"budget": {
-			"range": [
-				900,
-				1800,
-				300
-			]
+			"range":  { "low":900,"high":1800,"step":300 } 
 		},
 		"days": {
Index: src/main/webapp/domainsrepo/japantrip/japantrip1.json
===================================================================
--- src/main/webapp/domainsrepo/japantrip/japantrip1.json	(revision 27)
+++ src/main/webapp/domainsrepo/japantrip/japantrip1.json	(revision 28)
@@ -3,5 +3,5 @@
 		"issueUtilities": {
 			"place": {
-				"discreteutils": {
+				"DiscreteValueSetUtilities": {
 					"valueUtilities": {
 						"Tokyo": 1.0,
@@ -13,5 +13,5 @@
 			},
 			"budget": {
-				"numberutils": {
+				"NumberValueSetUtilities": {
 					"lowValue": 900,
 					"lowUtility": 1.0,
@@ -21,5 +21,5 @@
 			},
 			"days": {
-				"discreteutils": {
+				"DiscreteValueSetUtilities": {
 					"valueUtilities": {
 						"3": 1.0,
@@ -31,5 +31,5 @@
 			},
 			"purpose": {
-				"discreteutils": {
+				"DiscreteValueSetUtilities": {
 					"valueUtilities": {
 						"Sightseeing": 0.6,
@@ -58,9 +58,9 @@
 				},
 				"budget": {
-					"range": [
-						900,
-						1800,
-						300 
-					]
+					"range": {
+						"low": 900,
+						"high": 1800,
+						"step": 300
+					}
 				},
 				"days": {
Index: src/main/webapp/domainsrepo/japantrip/japantrip2.json
===================================================================
--- src/main/webapp/domainsrepo/japantrip/japantrip2.json	(revision 27)
+++ src/main/webapp/domainsrepo/japantrip/japantrip2.json	(revision 28)
@@ -3,5 +3,5 @@
 		"issueUtilities": {
 			"place": {
-				"discreteutils": {
+				"DiscreteValueSetUtilities": {
 					"valueUtilities": {
 						"Tokyo": 0.8,
@@ -13,13 +13,13 @@
 			},
 			"budget": {
-				"numberutils": {
+				"NumberValueSetUtilities": {
 					"lowValue": 900,
 					"lowUtility": 0.6,
 					"highValue": 1800,
-					"highUtility": 0.9 
+					"highUtility": 0.9
 				}
 			},
 			"days": {
-				"discreteutils": {
+				"DiscreteValueSetUtilities": {
 					"valueUtilities": {
 						"3": 0.25,
@@ -31,5 +31,5 @@
 			},
 			"purpose": {
-				"discreteutils": {
+				"DiscreteValueSetUtilities": {
 					"valueUtilities": {
 						"Sightseeing": 0.2,
@@ -58,9 +58,9 @@
 				},
 				"budget": {
-					"range": [
-						900,
-						1800,
-						300 
-					]
+					"range": {
+						"low": 900,
+						"high": 1800,
+						"step": 300
+					}
 				},
 				"days": {
Index: src/main/webapp/domainsrepo/jobs/jobs1.json
===================================================================
--- src/main/webapp/domainsrepo/jobs/jobs1.json	(revision 27)
+++ src/main/webapp/domainsrepo/jobs/jobs1.json	(revision 28)
@@ -3,5 +3,5 @@
 		"issueUtilities": {
 			"salary": {
-				"discreteutils": {
+				"DiscreteValueSetUtilities": {
 					"valueUtilities": {
 						"2000": 0,
@@ -14,5 +14,5 @@
 			},
 			"fte": {
-				"discreteutils": {
+				"DiscreteValueSetUtilities": {
 					"valueUtilities": {
 						"0.6": 0.25,
@@ -23,5 +23,5 @@
 			},
 			"work from home": {
-				"discreteutils": {
+				"DiscreteValueSetUtilities": {
 					"valueUtilities": {
 						"0": 0.333333333,
@@ -32,5 +32,5 @@
 			},
 			"lease car": {
-				"discreteutils": {
+				"DiscreteValueSetUtilities": {
 					"valueUtilities": {
 						"yes": 1,
@@ -40,5 +40,5 @@
 			},
 			"permanent contract": {
-				"discreteutils": {
+				"DiscreteValueSetUtilities": {
 					"valueUtilities": {
 						"yes": 1,
@@ -48,5 +48,5 @@
 			},
 			"career development opportunities": {
-				"discreteutils": {
+				"DiscreteValueSetUtilities": {
 					"valueUtilities": {
 						"low": 0,
Index: src/main/webapp/domainsrepo/jobs/jobs2.json
===================================================================
--- src/main/webapp/domainsrepo/jobs/jobs2.json	(revision 27)
+++ src/main/webapp/domainsrepo/jobs/jobs2.json	(revision 28)
@@ -3,5 +3,5 @@
 		"issueUtilities": {
 			"salary": {
-				"discreteutils": {
+				"DiscreteValueSetUtilities": {
 					"valueUtilities": {
 						"2000": 1.0,
@@ -14,5 +14,5 @@
 			},
 			"fte": {
-				"discreteutils": {
+				"DiscreteValueSetUtilities": {
 					"valueUtilities": {
 						"0.6": 0.363636363636363636,
@@ -23,5 +23,5 @@
 			},
 			"work from home": {
-				"discreteutils": {
+				"DiscreteValueSetUtilities": {
 					"valueUtilities": {
 						"0": 1.0,
@@ -32,5 +32,5 @@
 			},
 			"lease car": {
-				"discreteutils": {
+				"DiscreteValueSetUtilities": {
 					"valueUtilities": {
 						"yes": 0,
@@ -40,5 +40,5 @@
 			},
 			"permanent contract": {
-				"discreteutils": {
+				"DiscreteValueSetUtilities": {
 					"valueUtilities": {
 						"yes": 0.23809523809523808,
@@ -48,5 +48,5 @@
 			},
 			"career development opportunities": {
-				"discreteutils": {
+				"DiscreteValueSetUtilities": {
 					"valueUtilities": {
 						"low": 1.0,
Index: src/main/webapp/domainsrepo/laptop/laptopBuyer.json
===================================================================
--- src/main/webapp/domainsrepo/laptop/laptopBuyer.json	(revision 27)
+++ src/main/webapp/domainsrepo/laptop/laptopBuyer.json	(revision 28)
@@ -3,5 +3,5 @@
 		"issueUtilities": {
 			"Brand": {
-				"discreteutils": {
+				"DiscreteValueSetUtilities": {
 					"valueUtilities": {
 						"Dell": 0.33,
@@ -12,5 +12,5 @@
 			},
 			"Harddisk": {
-				"discreteutils": {
+				"DiscreteValueSetUtilities": {
 					"valueUtilities": {
 						"128 GB": 1,
@@ -21,5 +21,5 @@
 			},
 			"External Monitor": {
-				"discreteutils": {
+				"DiscreteValueSetUtilities": {
 					"valueUtilities": {
 						"19inch HD": 1,
Index: src/main/webapp/domainsrepo/laptop/laptopSeller.json
===================================================================
--- src/main/webapp/domainsrepo/laptop/laptopSeller.json	(revision 27)
+++ src/main/webapp/domainsrepo/laptop/laptopSeller.json	(revision 28)
@@ -3,5 +3,5 @@
 		"issueUtilities": {
 			"Brand": {
-				"discreteutils": {
+				"DiscreteValueSetUtilities": {
 					"valueUtilities": {
 						"Dell": 0.34,
@@ -12,5 +12,5 @@
 			},
 			"Harddisk": {
-				"discreteutils": {
+				"DiscreteValueSetUtilities": {
 					"valueUtilities": {
 						"128 GB": 0.65,
@@ -21,5 +21,5 @@
 			},
 			"External Monitor": {
-				"discreteutils": {
+				"DiscreteValueSetUtilities": {
 					"valueUtilities": {
 						"19inch HD": 1,
Index: src/main/webapp/domainsrepo/party/party1.json
===================================================================
--- src/main/webapp/domainsrepo/party/party1.json	(revision 27)
+++ src/main/webapp/domainsrepo/party/party1.json	(revision 28)
@@ -4,5 +4,5 @@
 		"issueUtilities": {
 			"Food": {
-				"discreteutils": {
+				"DiscreteValueSetUtilities": {
 					"valueUtilities": {
 						"Chips and Nuts": 0.75,
@@ -14,5 +14,5 @@
 			},
 			"Drinks": {
-				"discreteutils": {
+				"DiscreteValueSetUtilities": {
 					"valueUtilities": {
 						"Non-Alcoholic": 0.263,
@@ -24,5 +24,5 @@
 			},
 			"Location": {
-				"discreteutils": {
+				"DiscreteValueSetUtilities": {
 					"valueUtilities": {
 						"Party Tent": 0.52,
@@ -34,5 +34,5 @@
 			},
 			"Invitations": {
-				"discreteutils": {
+				"DiscreteValueSetUtilities": {
 					"valueUtilities": {
 						"Plain": 0.24,
@@ -44,5 +44,5 @@
 			},
 			"Music": {
-				"discreteutils": {
+				"DiscreteValueSetUtilities": {
 					"valueUtilities": {
 						"MP3": 0.65,
@@ -53,5 +53,5 @@
 			},
 			"Cleanup": {
-				"discreteutils": {
+				"DiscreteValueSetUtilities": {
 					"valueUtilities": {
 						"Water and Soap": 0.65,
Index: src/main/webapp/domainsrepo/party/party1partial.json
===================================================================
--- src/main/webapp/domainsrepo/party/party1partial.json	(revision 27)
+++ src/main/webapp/domainsrepo/party/party1partial.json	(revision 28)
@@ -27,5 +27,5 @@
 		"partUtilities": {
 			"food&drinks": {
-				"partsutils": {
+				"PartsUtilities": {
 					"issues": ["Drinks", "Food"],
 					"utilslist": [{
@@ -81,5 +81,5 @@
 			},
 			"Invitations": {
-				"partsutils": {
+				"PartsUtilities": {
 					"issues": ["Invitations"],
 					"utilslist": [{
@@ -99,5 +99,5 @@
 			},
 			"Cleanup": {
-				"partsutils": {
+				"PartsUtilities": {
 					"issues": ["Cleanup"],
 					"utilslist": [{
@@ -117,5 +117,5 @@
 			},
 			"Music": {
-				"partsutils": {
+				"PartsUtilities": {
 					"issues": ["Music"],
 					"utilslist": [{
@@ -132,5 +132,5 @@
 			},
 			"Location": {
-				"partsutils": {
+				"PartsUtilities": {
 					"issues": ["Location"],
 					"utilslist": [{
Index: src/main/webapp/domainsrepo/party/party2.json
===================================================================
--- src/main/webapp/domainsrepo/party/party2.json	(revision 27)
+++ src/main/webapp/domainsrepo/party/party2.json	(revision 28)
@@ -4,5 +4,5 @@
 		"issueUtilities": {
 			"Food": {
-				"discreteutils": {
+				"DiscreteValueSetUtilities": {
 					"valueUtilities": {
 						"Chips and Nuts": 0.24,
@@ -14,5 +14,5 @@
 			},
 			"Drinks": {
-				"discreteutils": {
+				"DiscreteValueSetUtilities": {
 					"valueUtilities": {
 						"Non-Alcoholic": 0.33,
@@ -24,5 +24,5 @@
 			},
 			"Location": {
-				"discreteutils": {
+				"DiscreteValueSetUtilities": {
 					"valueUtilities": {
 						"Party Tent": 0.3,
@@ -34,5 +34,5 @@
 			},
 			"Invitations": {
-				"discreteutils": {
+				"DiscreteValueSetUtilities": {
 					"valueUtilities": {
 						"Plain": 0.84,
@@ -44,5 +44,5 @@
 			},
 			"Music": {
-				"discreteutils": {
+				"DiscreteValueSetUtilities": {
 					"valueUtilities": {
 						"MP3": 0.94,
@@ -53,5 +53,5 @@
 			},
 			"Cleanup": {
-				"discreteutils": {
+				"DiscreteValueSetUtilities": {
 					"valueUtilities": {
 						"Water and Soap": 1,
Index: src/main/webapp/domainsrepo/party/party3.json
===================================================================
--- src/main/webapp/domainsrepo/party/party3.json	(revision 27)
+++ src/main/webapp/domainsrepo/party/party3.json	(revision 28)
@@ -4,5 +4,5 @@
 		"issueUtilities": {
 			"Food": {
-				"discreteutils": {
+				"DiscreteValueSetUtilities": {
 					"valueUtilities": {
 						"Chips and Nuts": 1,
@@ -14,5 +14,5 @@
 			},
 			"Drinks": {
-				"discreteutils": {
+				"DiscreteValueSetUtilities": {
 					"valueUtilities": {
 						"Non-Alcoholic": 0.99,
@@ -24,5 +24,5 @@
 			},
 			"Location": {
-				"discreteutils": {
+				"DiscreteValueSetUtilities": {
 					"valueUtilities": {
 						"Party Tent": 0.98,
@@ -34,5 +34,5 @@
 			},
 			"Invitations": {
-				"discreteutils": {
+				"DiscreteValueSetUtilities": {
 					"valueUtilities": {
 						"Plain": 0.99,
@@ -44,5 +44,5 @@
 			},
 			"Music": {
-				"discreteutils": {
+				"DiscreteValueSetUtilities": {
 					"valueUtilities": {
 						"MP3": 0.9,
@@ -53,5 +53,5 @@
 			},
 			"Cleanup": {
-				"discreteutils": {
+				"DiscreteValueSetUtilities": {
 					"valueUtilities": {
 						"Water and Soap": 1,
Index: src/main/webapp/domainsrepo/party/party4.json
===================================================================
--- src/main/webapp/domainsrepo/party/party4.json	(revision 27)
+++ src/main/webapp/domainsrepo/party/party4.json	(revision 28)
@@ -4,5 +4,5 @@
 		"issueUtilities": {
 			"Food": {
-				"discreteutils": {
+				"DiscreteValueSetUtilities": {
 					"valueUtilities": {
 						"Chips and Nuts": 0.98,
@@ -14,5 +14,5 @@
 			},
 			"Drinks": {
-				"discreteutils": {
+				"DiscreteValueSetUtilities": {
 					"valueUtilities": {
 						"Non-Alcoholic": 0.99,
@@ -24,5 +24,5 @@
 			},
 			"Location": {
-				"discreteutils": {
+				"DiscreteValueSetUtilities": {
 					"valueUtilities": {
 						"Party Tent": 0.58,
@@ -34,5 +34,5 @@
 			},
 			"Invitations": {
-				"discreteutils": {
+				"DiscreteValueSetUtilities": {
 					"valueUtilities": {
 						"Plain": 0.99,
@@ -44,5 +44,5 @@
 			},
 			"Music": {
-				"discreteutils": {
+				"DiscreteValueSetUtilities": {
 					"valueUtilities": {
 						"MP3": 0.65,
@@ -53,5 +53,5 @@
 			},
 			"Cleanup": {
-				"discreteutils": {
+				"DiscreteValueSetUtilities": {
 					"valueUtilities": {
 						"Water and Soap": 0.27,